/*
 * Copyright (c) 2008 - 2012, Andy Bierman, All Rights Reserved.
 * Copyright (c) 2012 - 2020, YumaWorks, Inc., All Rights Reserved.
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 *

*** Generated by yangdump-sdk

    Combined SIL-SA module
    module test-hardware
    revision 2020-08-19
    namespace urn:ietf:params:xml:ns:yang:test-hardware
    Created: 2020-08-19T17:41:59Z
    CLI parameters:
        format c
        indent 4
        log-level debug3
        module test-hardware
        output test-hardware.c
        sil-get2
        sil-sa
        unified true

 */

#include <xmlstring.h>

#include "procdefs.h"
#include "agt.h"
#include "agt_action.h"
#include "agt_cb.h"
#include "agt_rpc.h"
#include "agt_sil_lib.h"
#include "agt_timer.h"
#include "agt_util.h"
#include "agt_val.h"
#include "cfg.h"
#include "dlq.h"
#include "getcb.h"
#include "ncx.h"
#include "ncx_feature.h"
#include "ncxmod.h"
#include "ncxtypes.h"
#include "obj.h"
#include "rpc.h"
#include "sil_sa.h"
#include "status.h"
#include "val.h"
#include "val_child.h"
#include "val_util.h"
#include "xml_val.h"
#include "test-hardware.h"

/* module static variables */
static ncx_module_t *test_hardware_mod;

/* put your static variables here */

/********************************************************************
* FUNCTION print_callback_info
*
* Dump current Callback info
*
********************************************************************/
static void
    print_callback_info (val_value_t *useval,
                         agt_cbtyp_t cbtyp,
                         op_editop_t editop,
                         const xmlChar *callback_name)
{
    if (LOGDEBUG) {
        log_debug("\n (%s) Enter %s callback"
            "\n ------PHASE:%s;EDITOP:%s\n",
            useval ? VAL_NAME(useval) : NCX_NT_NONE,
            callback_name,
            agt_cbtype_name(cbtyp),
            op_editop_name(editop));
    }

} /* print_callback_info */


/********************************************************************
* FUNCTION y_test_hardware_init_static_vars
*
* initialize module static variables
*
********************************************************************/
static void y_test_hardware_init_static_vars (void)
{
    test_hardware_mod = NULL;

    /* init your static variables here */

} /* y_test_hardware_init_static_vars */


/********************************************************************
* FUNCTION test_hardware_get
*
* Get database object callback for leaf description
*
* Path: leaf /hardware/component/description
*
* Fill in 'get2cb' response fields
*
* INPUTS:
*     see ncx/getcb.h for details (getcb_fn2_t)
*
* RETURNS:
*     error status
********************************************************************/
static status_t
    test_hardware_get (ses_cb_t *scb,
                       xml_msg_hdr_t *msg,
                       getcb_get2_t *get2cb)
{
    if (LOGDEBUG) {
        log_debug("\nEnter test_hardware_get");
    }

    (void)scb;
    (void)msg;

    val_value_t *keyval = NULL;

    /* ancestor key test-hardware:name */
    const xmlChar *k_hardware_component_name = NULL;
    keyval =
        getcb_find_key_lvl(get2cb,
                           y_test_hardware_M_test_hardware,
                           y_test_hardware_N_name,
                           (uint32)3);
    if (keyval) {
        k_hardware_component_name = VAL_STRING(keyval);

        if (k_hardware_component_name) {
            log_info("\n\n Parent key value is:%s",
                     k_hardware_component_name);
        }
    }

    /* check the callback mode type */
    getcb_mode_t cbmode = GETCB_GET2_CBMODE(get2cb);
    switch (cbmode) {
    case GETCB_GET_VALUE:
        break;
    case GETCB_GETNEXT_VALUE:
        return ERR_NCX_NO_INSTANCE;
    default:
        return SET_ERROR(ERR_INTERNAL_VAL);
    }

    /* check if the requested node exists; determined by the
     * SIL or SIL-SA callback based on instances in the system
     * CHANGE node_exists TO TRUE WHEN VALUE CODE FILLED IN */
    boolean node_exists = FALSE;

    if (!node_exists) {
        return ERR_NCX_NO_INSTANCE;
    }

    obj_template_t *obj = GETCB_GET2_OBJ(get2cb);
    status_t res = NO_ERR;

    /* get the real value from the system somehow */
    const xmlChar *v_description = 0;

    /* add description to get2cb return_valQ */
    val_value_t *return_val =
        agt_make_leaf2(obj,
                       y_test_hardware_M_test_hardware,
                       y_test_hardware_N_description,
                       v_description,
                       &res);
    if (return_val) {
        getcb_add_return_val(get2cb, return_val);
    }

    return res;

} /* test_hardware_get */


/********************************************************************
* FUNCTION test_hardware_edit
*
* Edit database object callback
* Path: leaf /hardware/component/parent
* Path: leaf /hardware/component/alias
* Path: list /hardware/component
* Path: container /hardware
*
* Add object instrumentation in COMMIT phase.
*
* INPUTS:
*     see agt/agt_cb.h for details
*
* RETURNS:
*     error status
********************************************************************/
static status_t
    test_hardware_edit (ses_cb_t *scb,
                        rpc_msg_t *msg,
                        agt_cbtyp_t cbtyp,
                        op_editop_t editop,
                        val_value_t *newval,
                        val_value_t *curval)
{
    status_t res = NO_ERR;
    val_value_t *errorval = (curval) ? curval : newval;
    uint32 cur_errs = agt_get_error_count(msg);

    print_callback_info(errorval, cbtyp, editop, (const xmlChar *)"EDIT");

    /* ancestor key test-hardware:name */
    const xmlChar *key_name = NULL;

    /* Get the key value node for the specified key
     * where 1 is a key index to get -- 1 to N
     */
    val_value_t *keyval = sil_sa_get_key(msg, 1);
    if (keyval) {
        key_name = VAL_STR(keyval);
        if (key_name) {
            log_info("\n\n Parent key value is:%s",
                     key_name);
        }
    }

    switch (cbtyp) {
    case AGT_CB_VALIDATE:
        /* description-stmt validation here */
        break;
    case AGT_CB_APPLY:
        /* database manipulation done here */
        break;
    case AGT_CB_COMMIT:
        /* device instrumentation done here */
        switch (editop) {
        case OP_EDITOP_LOAD:
            break;
        case OP_EDITOP_MERGE:
            break;
        case OP_EDITOP_REPLACE:
            break;
        case OP_EDITOP_CREATE:
            break;
        case OP_EDITOP_DELETE:
            break;
        default:
            res = SET_ERROR(ERR_INTERNAL_VAL);
        }
        break;
    case AGT_CB_ROLLBACK:
        /* undo device instrumentation here */
        break;
    default:
        res = SET_ERROR(ERR_INTERNAL_VAL);
    }

    if ((res != NO_ERR) && (cur_errs == agt_get_error_count(msg))) {
        agt_record_error(scb,
                         &msg->mhdr,
                         NCX_LAYER_CONTENT,
                         res,
                         NULL,
                         (errorval) ? NCX_NT_VAL : NCX_NT_NONE,
                         errorval,
                         (errorval) ? NCX_NT_VAL : NCX_NT_NONE,
                         errorval);
    }
    return res;

} /* test_hardware_hardware_component_parent_edit */


/********************************************************************
* FUNCTION y_test_hardware_init
*
* initialize the test-hardware server instrumentation library
*
* INPUTS:
*    modname == requested module name
*    revision == requested version (NULL for any)
*
* RETURNS:
*     error status
********************************************************************/
status_t
    y_test_hardware_init (const xmlChar *modname,
                          const xmlChar *revision)
{
    status_t res = NO_ERR;

    y_test_hardware_init_static_vars();

    /* change if custom handling done */
    if (xml_strcmp(modname, y_test_hardware_M_test_hardware)) {
        return ERR_NCX_UNKNOWN_MODULE;
    }

    if (revision && xml_strcmp(revision, y_test_hardware_R_test_hardware)) {
        return ERR_NCX_WRONG_VERSION;
    }

    res =
        ncxmod_load_module(y_test_hardware_M_test_hardware,
                           y_test_hardware_R_test_hardware,
                           agt_get_savedevQ(),
                           &test_hardware_mod);
    if (res != NO_ERR) {
        return res;
    }

    res =
        agt_cb_register_callback(y_test_hardware_M_test_hardware,
                                 (const xmlChar *)"/test-hw:hardware",
                                 y_test_hardware_R_test_hardware,
                                 test_hardware_edit);
    if (res != NO_ERR) {
        return res;
    }

    res =
        agt_cb_register_callback(y_test_hardware_M_test_hardware,
                                (const xmlChar *)"/test-hw:hardware/test-hw:component",
                                y_test_hardware_R_test_hardware,
                                test_hardware_edit);
    if (res != NO_ERR) {
        return res;
    }

    res =
        agt_cb_register_callback(y_test_hardware_M_test_hardware,
                    (const xmlChar *)"/test-hw:hardware/test-hw:component/test-hw:parent",
                                 y_test_hardware_R_test_hardware,
                                 test_hardware_edit);
    if (res != NO_ERR) {
        return res;
    }

    res =
        agt_cb_register_callback(y_test_hardware_M_test_hardware,
                        (const xmlChar *)"/test-hw:hardware/test-hw:component/test-hw:alias",
                                 y_test_hardware_R_test_hardware,
                                 test_hardware_edit);
    if (res != NO_ERR) {
        return res;
    }

    res =
        agt_cb_register_get_callback(y_test_hardware_M_test_hardware,
                    (const xmlChar *)"/test-hw:hardware/test-hw:component/test-hw:description",
                                     y_test_hardware_R_test_hardware,
                                     test_hardware_get);
    if (res != NO_ERR) {
        return res;
    }

    /* put your module initialization code here */

    return res;

} /* y_test_hardware_init */

/********************************************************************
* FUNCTION y_test_hardware_init2
*
* SIL init phase 2: non-config data structures
* Called after running config is loaded
*
* RETURNS:
*     error status
********************************************************************/
status_t y_test_hardware_init2 (void)
{
    status_t res = NO_ERR;

    /* put your init2 code here */

    return res;

} /* y_test_hardware_init2 */

/********************************************************************
* FUNCTION y_test_hardware_cleanup
*    cleanup the server instrumentation library
*
********************************************************************/
void y_test_hardware_cleanup (void)
{

    agt_cb_unregister_callbacks(
        y_test_hardware_M_test_hardware,
        (const xmlChar *)"/test-hw:hardware");

    agt_cb_unregister_callbacks(
        y_test_hardware_M_test_hardware,
        (const xmlChar *)"/test-hw:hardware/test-hw:component");

    /* put your cleanup code here */

} /* y_test_hardware_cleanup */

/* END SIL-SA test_hardware.c */
